<template>
	<div class="business-end-container layout-pd">
		<!-- 搜索  -->
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item label="关键词" prop="Keyword">
					<el-input v-model="state.queryParams.Keyword" placeholder="工单编码/标题" clearable @keyup.enter="queryList" class="keyword-input" />
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" v-waves class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<ProTable
				ref="proTableRef"
				:columns="columns"
				:data="state.tableData"
				@updateTable="queryList"
				:loading="state.loading"
				:total="state.total"
				v-model:page-index="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
			>
				<template #tableHeader="scope">
					<el-button type="primary" @click="oncancelEnd" v-auth="'business:order:end'" :disabled="!scope.isSelected">
						<SvgIcon name="ele-Stopwatch" class="mr5" />取消终结件
					</el-button>
				</template>
				<template #expiredStatus="{ row }">
					<span :class="'overdue-status-' + row.order?.expiredStatus" :title="row.order?.expiredStatusText"></span>
				</template>
				<template #isProvince="{ row }">
					<span>{{ row.order?.isProvince ? '省工单' : '市工单' }}</span>
				</template>
				<template #title="{ row }">
					<order-detail :order="row.order" @updateList="queryList">{{ row.order?.title }}</order-detail>
				</template>
				<!-- 表格操作 -->
				<template #operation="{ row }">
					<order-detail :order="row.order" @updateList="queryList" />
				</template>
			</ProTable>
		</el-card>
	</div>
</template>
<script setup lang="tsx" name="businessEnd">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElButton, ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { auth } from '@/utils/authFunction';
import { throttle } from '@/utils/tools';
import { formatDate } from '@/utils/formatTime';
import { useRouter } from 'vue-router';
import { deleteEnd, endList } from '@/api/query/end';
// 引入组件
const OrderDetail = defineAsyncComponent(() => import('@/components/OrderDetail/index.vue')); // 工单详情
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const router = useRouter(); // 路由
const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
	{ type: 'selection', fixed: 'left', width: 55 },
	{ prop: 'expiredStatus', label: '超期状态', align: 'center' },
	{ prop: 'order.no', label: '工单编码', width: 150 },
	{ prop: 'order.sourceChannel', label: '来源方式', width: 120 },
	{ prop: 'order.actualHandleStepName', label: '当前节点', width: 120 },
	{ prop: 'isProvince', label: '省/市工单', width: 100 },
	{
		prop: 'order.expiredTime',
		label: '工单期满时间',
		width: 170,
		render: (scope: any) => {
			return <span>{formatDate(scope.row.order?.expiredTime, 'YYYY-mm-dd HH:MM:SS')}</span>;
		},
	},
	{
		prop: 'order.startTime',
		label: '受理时间',
		width: 170,
		render: (scope: any) => {
			return <span>{formatDate(scope.row.order?.startTime, 'YYYY-mm-dd HH:MM:SS')}</span>;
		},
	},
	{ prop: 'order.acceptType', label: '受理类型', width: 150 },
	{ prop: 'order.statusText', label: '工单状态', width: 100 },
	{ prop: 'order.title', label: '工单标题', width: 300 },
	{ prop: 'order.actualHandleOrgName', label: '接办部门', width: 170 },
	{
		prop: 'order.actualHandleTime',
		label: '接办时间',
		width: 170,
		render: (scope: any) => {
			return <span>{formatDate(scope.row.order?.actualHandleTime, 'YYYY-mm-dd HH:MM:SS')}</span>;
		},
	},
	{ prop: 'order.hotspotName', label: '热点分类', width: 120 },
	{ prop: 'creatorOrgName', label: '设置部门', minWidth: 200 },
	{ prop: 'creatorName', label: '设置人', minWidth: 120 },
	{
		prop: 'creationTime',
		label: '设置时间',
		width: 170,
		render: (scope: any) => {
			return <span>{formatDate(scope.row.creationTime, 'YYYY-mm-dd HH:MM:SS')}</span>;
		},
	},
	{ prop: 'operation', label: '操作', fixed: 'right', width: 140, align: 'center' },
]);
const state = reactive({
	queryParams: {
		// 查询条件
		PageIndex: 1,
		PageSize: 10,
		Keyword: null, // 关键字
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
});
/** 获取列表 */
const queryList = throttle(() => {
	state.loading = true;
	endList(state.queryParams)
		.then((res) => {
			state.tableData = res?.result.items ?? [];
			state.total = res?.result.total;
			state.loading = false;
		})
		.finally(() => {
			state.loading = false;
		});
}, 300);

/** 重置按钮操作 */
const resetQuery = throttle((formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
}, 300);
// 取消终结件
const oncancelEnd = () => {
	const titles = proTableRef.value.selectedList.map((item: any) => item.order?.title).join(',');
	const ids = proTableRef.value.selectedList.map((item: any) => item.id);
	ElMessageBox.confirm(`确定要取消【${titles}】终结件吗？`, '提示', {
		confirmButtonText: '确定',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		autofocus: false,
	})
		.then(() => {
			deleteEnd({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
onMounted(() => {
	queryList();
});
</script>
